#line 1 "C:/Users/pietro/Desktop/PIC clicker/USB/HID_Read_Write_Interrupt.c"
#line 25 "C:/Users/pietro/Desktop/PIC clicker/USB/HID_Read_Write_Interrupt.c"
sbit LD1 at LATA0_bit;
sbit LD2 at LATA1_bit;
sbit LD1_Direction at TRISA0_bit;
sbit LD2_Direction at TRISA1_bit;
sbit T1 at RD3_bit;
sbit T2 at RD2_bit;
sbit T1_Direction at TRISD3_bit;
sbit T2_Direction at TRISD2_bit;

unsigned char readbuff[64] absolute 0x500;
unsigned char writebuff[64] absolute 0x540;

unsigned char modifier=0b00000000;
unsigned char rsv=0;
unsigned char keycode[6];

char cnt = 0x04;
char oldstate1 = 0;
char oldstate2 = 0;

void interrupt(){
 USB_Interrupt_Proc();
}

void reset_keycode()
{
 modifier=0;
 keycode[0]=0;
 keycode[1]=0;
 keycode[2]=0;
 keycode[3]=0;
 keycode[4]=0;
 keycode[5]=0;
 writebuff[0]=0x00;
 writebuff[1]=rsv;
 writebuff[2]=keycode[0];
 writebuff[3]=keycode[1];
 writebuff[4]=keycode[2];
 writebuff[5]=keycode[3];
 writebuff[6]=keycode[4];
 writebuff[7]=keycode[5];
}

void send_key(unsigned char key, unsigned char mod)
{
 keycode[0] = key;

 writebuff[0]=mod;
 writebuff[1]=rsv;
 writebuff[2]=keycode[0];
 writebuff[3]=keycode[1];
 writebuff[4]=keycode[2];
 writebuff[5]=keycode[3];
 writebuff[6]=keycode[4];
 writebuff[7]=keycode[5];

 while(!HID_Write(&writebuff,8));
 delay_ms(30);

 reset_keycode();
 while(!HID_Write(&writebuff,8));
 delay_ms(30);

}

void main()
{
 ANCON0 = 0;
 ANCON1 = 0;
 T1_Direction = 1;
 T2_Direction = 1;
 LD1_Direction = 0;
 LD2_Direction = 0;
 LD1 = 0;
 LD2 = 0;

 HID_Enable(&readbuff, &writebuff);
 GIE_bit = 1;


 while(1)
 {
 reset_keycode();


 if (Button(&PORTD, 3, 2, 0)) {
 oldstate1 = 1;
 LD1 = 1;
 }
 if (oldstate1 && Button(&PORTD, 3, 2, 1)) {
 oldstate1 = 0;
 send_key(0x19,0x01);
 LD1 ^= 1;
 }

 if (Button(&PORTD, 2, 2, 0)) {
 oldstate2 = 1;
 LD2 = 1;
 }
 if (oldstate2 && Button(&PORTD, 2, 2, 1)) {
 oldstate2 = 0;
 send_key(0x06, 0x01);
 LD2 ^= 1;
 }


 }
}
